#!/bin/bash

set -e

the_script=`readlink -f ${BASH_SOURCE[0]}`

if [ ! -f jb-.dump ]; then
    if [ ! -f jb.dump ]; then
        wget http://www.sai.msu.su/~megera/postgres/files/jb.dump.gz -O - | gunzip > jb.dump
    fi
    dl0=`grep -n -m 1 'COPY jb (jb) FROM stdin' jb.dump | cut -f1 -d:`
    sed -n "1","$((dl0 + 100000))"p jb.dump >jb-.dump
    dle=$(sed -n "$((dl0 + 100000 + 1)),$ "p jb.dump | grep -n -m 1 -e '^\\.$' | cut -f1 -d:)
    sed -n "$((dle + dl0 + 100000))","$"p jb.dump >>jb-.dump
    rm jb.dump
fi

if [ ! -f review.json-.dump ]; then
    if [ ! -f review.json.dump ]; then
        wget http://www.sai.msu.su/~megera/postgres/files/review.json.dump.gz -O - | gunzip > review.json.dump
    fi
    dl0=`grep -n -m 1 'COPY review (r) FROM stdin;' review.json.dump | cut -f1 -d:`
    sed -n "1","$((dl0 + 100000))"p review.json.dump >review.json-.dump
    dle=$(sed -n "$((dl0 + 100000 + 1)),$ "p review.json.dump | grep -n -m 1 -e '^\\.$' | cut -f1 -d:)
    sed -n "$((dle + dl0 + 100000))","$"p review.json.dump >>review.json-.dump
    rm review.json.dump
fi

dropdb json_test || true
createdb json_test --locale="en_US.UTF-8" --template=template0
psql -d json_test -f jb-.dump
psql -d json_test -f review.json-.dump
wget http://www.sai.msu.su/~megera/postgres/files/house.sql -O -| psql -d json_test
(
cd /tmp
pg_dump --create --no-owner json_test -f json_test-db.sql
[ -f json_test.zip ] && rm json_test.zip
zip -j json_test.zip json_test-db.sql $the_script
)